//### This file created by BYACC 1.8(/Java extension  1.1)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//###           06 Aug 00  -- Bob Jamison -- made state variables class-global
//###           03 Jan 01  -- Bob Jamison -- improved flags, tracing
//###           16 May 01  -- Bob Jamison -- added custom stack sizing
//### Please send bug reports to rjamison@lincom-asg.com
//### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";



package com.thoughtworks.qdox.parser.impl;



//#line 2 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
import com.thoughtworks.qdox.parser.*;
import com.thoughtworks.qdox.parser.structs.*;
import com.thoughtworks.qdox.model.*;
import com.thoughtworks.qdox.model.annotation.*;
import java.io.IOException;
import java.util.LinkedList;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;
//#line 25 "Parser.java"




/**
 * Encapsulates yacc() parser functionality in a Java
 *        class for quick code development
 */
public class Parser
{

boolean yydebug;        //do I want debug output?
int yynerrs;            //number of errors so far
int yyerrflag;          //was there an error?
int yychar;             //the current working character

//########## MESSAGES ##########
//###############################################################
// method: debug
//###############################################################
void debug(String msg)
{
  if (yydebug)
    System.out.println(msg);
}

//########## STATE STACK ##########
final static int YYSTACKSIZE = 500;  //maximum stack size
int statestk[],stateptr;           //state stack
int stateptrmax;                     //highest index of stackptr
int statemax;                        //state when highest index reached
//###############################################################
// methods: state stack push,pop,drop,peek
//###############################################################
void state_push(int state)
{
  if (stateptr>=YYSTACKSIZE)         //overflowed?
    return;
  statestk[++stateptr]=state;
  if (stateptr>statemax)
    {
    statemax=state;
    stateptrmax=stateptr;
    }
}
int state_pop()
{
  if (stateptr<0)                    //underflowed?
    return -1;
  return statestk[stateptr--];
}
void state_drop(int cnt)
{
int ptr;
  ptr=stateptr-cnt;
  if (ptr<0)
    return;
  stateptr = ptr;
}
int state_peek(int relative)
{
int ptr;
  ptr=stateptr-relative;
  if (ptr<0)
    return -1;
  return statestk[ptr];
}
//###############################################################
// method: init_stacks : allocate and prepare stacks
//###############################################################
boolean init_stacks()
{
  statestk = new int[YYSTACKSIZE];
  stateptr = -1;
  statemax = -1;
  stateptrmax = -1;
  val_init();
  return true;
}
//###############################################################
// method: dump_stacks : show n levels of the stacks
//###############################################################
void dump_stacks(int count)
{
int i;
  System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
  for (i=0;i<count;i++)
    System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
  System.out.println("======================");
}


//########## SEMANTIC VALUES ##########
//## **user defined:Value
String   yytext;//user variable to return contextual strings
Value yyval; //used to return semantic vals from action routines
Value yylval;//the 'lval' (result) I got from yylex()
Value valstk[];
int valptr;
//###############################################################
// methods: value stack push,pop,drop,peek.
//###############################################################
void val_init()
{
  valstk=new Value[YYSTACKSIZE];
  yyval=new Value();
  yylval=new Value();
  valptr=-1;
}
void val_push(Value val)
{
  if (valptr>=YYSTACKSIZE)
    return;
  valstk[++valptr]=val;
}
Value val_pop()
{
  if (valptr<0)
    return null;
  return valstk[valptr--];
}
void val_drop(int cnt)
{
int ptr;
  ptr=valptr-cnt;
  if (ptr<0)
    return;
  valptr = ptr;
}
Value val_peek(int relative)
{
int ptr;
  ptr=valptr-relative;
  if (ptr<0)
    return null;
  return valstk[ptr];
}
//#### end semantic value section ####
public final static short SEMI=257;
public final static short DOT=258;
public final static short DOTDOTDOT=259;
public final static short COMMA=260;
public final static short STAR=261;
public final static short PERCENT=262;
public final static short EQUALS=263;
public final static short ANNOSTRING=264;
public final static short ANNOCHAR=265;
public final static short SLASH=266;
public final static short PLUS=267;
public final static short MINUS=268;
public final static short PACKAGE=269;
public final static short IMPORT=270;
public final static short PUBLIC=271;
public final static short PROTECTED=272;
public final static short PRIVATE=273;
public final static short STATIC=274;
public final static short FINAL=275;
public final static short ABSTRACT=276;
public final static short NATIVE=277;
public final static short STRICTFP=278;
public final static short SYNCHRONIZED=279;
public final static short TRANSIENT=280;
public final static short VOLATILE=281;
public final static short CLASS=282;
public final static short INTERFACE=283;
public final static short ENUM=284;
public final static short ANNOINTERFACE=285;
public final static short THROWS=286;
public final static short EXTENDS=287;
public final static short IMPLEMENTS=288;
public final static short SUPER=289;
public final static short DEFAULT=290;
public final static short BRACEOPEN=291;
public final static short BRACECLOSE=292;
public final static short SQUAREOPEN=293;
public final static short SQUARECLOSE=294;
public final static short PARENOPEN=295;
public final static short PARENCLOSE=296;
public final static short LESSTHAN=297;
public final static short GREATERTHAN=298;
public final static short LESSEQUALS=299;
public final static short GREATEREQUALS=300;
public final static short LESSTHAN2=301;
public final static short GREATERTHAN2=302;
public final static short GREATERTHAN3=303;
public final static short EXCLAMATION=304;
public final static short AMPERSAND2=305;
public final static short VERTLINE2=306;
public final static short EQUALS2=307;
public final static short NOTEQUALS=308;
public final static short TILDE=309;
public final static short AMPERSAND=310;
public final static short VERTLINE=311;
public final static short CIRCUMFLEX=312;
public final static short VOID=313;
public final static short QUERY=314;
public final static short COLON=315;
public final static short AT=316;
public final static short JAVADOCSTART=317;
public final static short JAVADOCEND=318;
public final static short JAVADOCEOL=319;
public final static short CODEBLOCK=320;
public final static short PARENBLOCK=321;
public final static short BYTE=322;
public final static short SHORT=323;
public final static short INT=324;
public final static short LONG=325;
public final static short CHAR=326;
public final static short FLOAT=327;
public final static short DOUBLE=328;
public final static short BOOLEAN=329;
public final static short IDENTIFIER=330;
public final static short JAVADOCTAG=331;
public final static short JAVADOCLINE=332;
public final static short BOOLEAN_LITERAL=333;
public final static short INTEGER_LITERAL=334;
public final static short LONG_LITERAL=335;
public final static short FLOAT_LITERAL=336;
public final static short DOUBLE_LITERAL=337;
public final static short CHAR_LITERAL=338;
public final static short STRING_LITERAL=339;
public final static short YYERRCODE=256;
final static short yylhs[] = {                           -1,
    0,   35,    0,   34,   34,   34,   34,   34,   34,   34,
   36,   37,   37,   41,   41,   38,   42,   44,   44,   45,
   43,   43,   47,   46,   23,   23,   23,   31,   28,   28,
   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
   24,   48,   48,   48,   48,   50,    6,   49,   49,   49,
   49,   51,   51,   52,   53,    7,   54,   54,   55,   55,
    3,    3,    3,    4,    8,    8,    9,    9,   10,   10,
   11,   11,   12,   12,   13,   13,   14,   14,   14,   15,
   15,   15,   15,   15,   16,   16,   16,   16,   17,   17,
   17,   18,   18,   18,   18,   19,   19,   19,   20,   20,
   20,   21,   21,   21,   21,   21,   21,   21,   21,   21,
   21,   21,   22,   22,    1,    1,    5,    5,    5,    5,
    5,    5,    5,    2,    2,    2,    2,    2,    2,    2,
    2,   30,   57,   58,   32,   32,   25,   25,   26,   26,
   56,   56,   33,   33,   33,   33,   59,   59,   62,   60,
   61,   61,   63,   65,   63,   64,   64,   40,   66,   67,
   67,   69,   69,   69,   71,   71,   73,   73,   73,   73,
   39,   74,   75,   75,   75,   76,   76,   77,   77,   68,
   68,   78,   78,   70,   80,   70,   79,   79,   79,   79,
   79,   79,   79,   79,   27,   27,   84,   86,   81,   85,
   87,   85,   88,   85,   90,   82,   92,   82,   93,   83,
   94,   83,   89,   91,   91,   96,   96,   95,   95,   97,
   97,   98,   29,   29,   72,   72,   99,   99,   99,
};
final static short yylen[] = {                            2,
    0,    0,    3,    1,    1,    1,    1,    1,    1,    1,
    3,    3,    4,    1,    2,    4,    1,    0,    2,    1,
    0,    2,    0,    3,    1,    3,    3,    2,    0,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    2,    2,    0,    0,    4,    0,    3,    3,
    2,    1,    3,    3,    0,    4,    0,    1,    1,    3,
    1,    1,    1,    1,    1,    5,    1,    3,    1,    3,
    1,    3,    1,    3,    1,    3,    1,    3,    3,    1,
    3,    3,    3,    3,    1,    3,    3,    3,    1,    3,
    3,    1,    3,    3,    3,    2,    2,    1,    2,    2,
    1,    4,    5,    5,    4,    3,    1,    4,    3,    3,
    4,    1,    2,    3,    1,    3,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    0,    0,    6,    1,    1,    3,    1,    3,
    1,    3,    1,    1,    3,    3,    0,    1,    0,    4,
    1,    3,    1,    0,    4,    1,    3,    4,    4,    1,
    3,    0,    1,    3,    3,    2,    1,    2,    2,    3,
    4,    6,    1,    1,    1,    0,    2,    1,    3,    0,
    2,    1,    3,    0,    0,    3,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    2,    0,    6,    0,
    0,    4,    0,    5,    0,    9,    0,    8,    0,    6,
    0,    7,    3,    0,    2,    1,    3,    0,    1,    1,
    3,    4,    0,    1,    0,    2,    0,    2,    2,
};
final static short yydefred[] = {                         1,
    2,    0,   10,    0,    0,    0,   18,    4,    3,    5,
    6,    7,    8,    9,    0,    0,    0,   25,    0,    0,
    0,  115,    0,   21,    0,   31,   32,   33,   34,   35,
   36,   37,   41,   38,   40,   39,  173,  174,    0,  175,
   43,   42,   44,    0,    0,  184,   11,    0,    0,   12,
    0,    0,    0,   20,   19,    0,    0,   14,    0,    0,
    0,    0,    0,    0,   27,   26,   13,  116,    0,   47,
   16,   23,   22,    0,  159,  149,    0,  148,   15,    0,
  158,  184,    0,    0,  226,  166,  171,    0,    0,    0,
    0,   51,    0,    0,  125,  126,  127,  128,  129,  130,
  131,  124,    0,  121,  120,  119,  118,  117,  122,  123,
    0,    0,    0,   61,  107,   62,   63,   64,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   92,   98,
  101,    0,   52,    0,   18,  139,    0,    0,    0,    0,
    0,    0,    0,  165,    0,  164,  168,    0,  194,  187,
  192,  193,    0,  186,  188,  189,  190,  191,   96,   97,
    0,    0,    0,  100,   99,    0,    0,    0,    0,    0,
    0,   49,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   50,    0,    0,  133,    0,    0,    0,
    0,    0,  151,    0,    0,  172,  170,  197,    0,    0,
    0,    0,    0,    0,    0,    0,  106,   54,  110,  113,
    0,    0,  109,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   93,   95,   94,    0,   53,   59,    0,    0,    0,
  140,  138,    0,  154,    0,  150,    0,    0,    0,  198,
    0,    0,    0,  105,    0,  102,    0,  111,  114,  108,
    0,   56,    0,    0,  143,  141,    0,    0,  152,    0,
    0,    0,    0,    0,  200,    0,    0,  205,  104,  103,
   66,   60,    0,    0,    0,    0,  156,    0,    0,    0,
  220,    0,    0,    0,   29,    0,   30,    0,    0,  145,
  146,  142,  135,    0,  213,  227,  229,  228,    0,    0,
    0,  195,  196,  210,    0,    0,  199,    0,   29,  157,
  221,  224,    0,    0,    0,  203,    0,  212,    0,   29,
  222,    0,  208,    0,  202,    0,  204,  206,
};
final static short yydgoto[] = {                          1,
  111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
  121,  122,  123,  124,  125,  126,  127,  128,  129,  130,
  131,  169,   19,   42,  137,  138,  324,  283,  333,  275,
  260,  211,  276,    9,    2,   10,   11,   43,   13,   14,
   59,   24,   53,   25,   55,   73,  135,   15,   70,   52,
  132,  133,  134,  248,  249,  277,  250,  296,   77,   78,
  202,  141,  203,  298,  278,   16,   60,   75,   61,   64,
   62,   63,   86,   17,   44,  143,  205,  140,  154,   88,
  155,  156,  157,  158,  306,  285,  337,  344,  282,  309,
  304,  284,  258,  287,  299,  321,  300,  301,  302,
};
final static short yysindex[] = {                         0,
    0, -153,    0, -297, -257, -278,    0,    0,    0,    0,
    0,    0,    0,    0,  825, -181, -162,    0,   98, -297,
  123,    0,  -78,    0, -161,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -111,    0,
    0,    0,    0,  -36,  -50,    0,    0, -248,  126,    0,
   19,   33, -283,    0,    0,   42,   55,    0,  -50,  104,
  146,  140,    3,  118,    0,    0,    0,    0,  -86,    0,
    0,    0,    0,   92,    0,    0,  145,    0,    0,    3,
    0,    0,  -50,   66,    0,    0,    0, -238, -184, -184,
 -184,    0, -184, -184,    0,    0,    0,    0,    0,    0,
    0,    0,  174,    0,    0,    0,    0,    0,    0,    0,
 -224, -124,  175,    0,    0,    0,    0,    0,   39,  192,
  189,  191,  194,   82,  144,  -75,  179,  143,    0,    0,
    0, -228,    0,  210,    0,    0,  208,  249,  250,  251,
  180,   92,   42,    0,    0,    0,    0,  204,    0,    0,
    0,    0,  182,    0,    0,    0,    0,    0,    0,    0,
 -166, -136,  213,    0,    0,   90, -268,  232,  -80,  245,
  -47,    0, -184, -184, -184, -184, -184, -184, -184, -184,
 -184, -184, -184, -184, -184, -184, -184, -184, -184, -184,
 -184, -184,  198,    0,   90, -161,    0,  200,  201,   92,
  246, -239,    0,  250,  272,    0,    0,    0,    0,  205,
  250,  206,  835,  -92, -184,  -79,    0,    0,    0,    0,
  252,  243,    0,  258,  192,  228,  189,  191,  194,   82,
  144,  144,  -75,  -75,  -75,  -75,  179,  179,  179,  143,
  143,    0,    0,    0,  174,    0,    0,  253,  284, -270,
    0,    0,  250,    0,  180,    0,   92,  254,    0,    0,
  257,    0,  221,    0,  835,    0, -184,    0,    0,    0,
 -184,    0,   90,   36,    0,    0,  293,   92,    0,  250,
    0,  266,  257,  254,    0,  260,  254,    0,    0,    0,
    0,    0,   92,   92, -270,  259,    0,  255,  263,  295,
    0,  242, -297, -231,    0, -215,    0,  266,  254,    0,
    0,    0,    0,   92,    0,    0,    0,    0,  297,  302,
  304,    0,    0,    0, -174,  -50,    0, -231,    0,    0,
    0,    0,  236, -297, -231,    0,  236,    0, -174,    0,
    0,  302,    0,  236,    0, -231,    0,    0,
};
final static short yyrindex[] = {                         0,
    0,  904,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    1,    0,  -63,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -245,    0,    0,    0,    0,    0,
    0,   30,    0,    0,    0,  279,  -25,    0,   61,    0,
  282, -237,    0,   91,    0,    0,    0,    0,  305,    0,
    0,    0,    0,    0,    0,    0, -273,    0,    0,    0,
    0,    0, -245,   -3,    0,    0,    0,  209,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  280,    0,    0,    0,    0,    0,    0,    0,
  301,    0,    0,    0,    0,    0,    0,    0,  -27,  769,
  754,  727,  329,  -90,  630,  518,  399,  350,    0,    0,
    0,    0,    0,    0,    0,    0, -235,  142,  -57,  314,
    0,    0,  279,    0,  -85,    0,    0,   -1,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  826,    0,    0,    0,    0,  305,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  178,   64,    0,    0,    0,    0,
 -172,    0,    0,  -83, -129,    0,    0,    0, -217,    0,
  138,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  771,    0,  766,  738,  710,  689,
  651,  668,  546,  567,  588,  609,  448,  469,  497,  371,
  420,    0,    0,    0,    0,    0,    0,    0,  283,    0,
    0,    0,  -31,    0,    0,    0,    0,    0, -221,    0,
 -195, -197,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  305, -137,    0,    0,  273,    0,    0,    4,
   63, -230, -229,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -123,    0,  288,
    0,    0,    0,    0,    0,    0,    0, -230,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  265, -211,
 -219,    0,    0,    0, -230,  180,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -230,    0,
    0, -206,    0,    0,    0,    0,    0,    0,
};
final static short yygindex[] = {                         0,
    2,  523, -155,  -87,    0,   14,    0,    0,    0,  446,
  445,  447,  449,  444,  298,  292,  264,  307,  -84, -163,
    0,   12,   17,  322,    0,    0, -170, -208,    0, -146,
  101,  -72,  332,    0,    0,    0,    0,   -2,  540,  541,
    0,    0,    0,  495,    0,    0,    0,  544,    0,    0,
    0,  440,    0,    0,    0,    0,    0,    0,    0,  483,
    0,    0,  382,    0,    0,    0,    0,  502,  571,  584,
    0,  616,  604,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
   53,    0,    0,    0,    0,    0,    0,  373,    0,
};
final static int YYTABLESIZE=1189;
final static short yytable[] = {                         12,
   46,  139,  261,  163,  159,  160,  210,   23,  164,  165,
  218,  162,   65,  219,  176,    8,   20,  176,  149,  163,
  255,   21,  136,  136,  136,  322,  214,   28,   41,   48,
   28,  193,   18,  167,   71,   29,   49,  215,   29,  247,
  139,  322,   58,  274,  326,  216,  162,   72,  216,  264,
  217,   22,  136,  217,  163,  136,   79,  136,  256,  136,
  139,   68,  136,  132,  132,  263,   28,  194,  168,  204,
  225,   29,   18,  207,  136,  139,   85,  209,    7,  139,
   58,   66,   89,   90,  225,  150,  226,  153,  323,  214,
   28,  167,  161,   85,  136,  139,  325,  211,   29,  139,
  215,  289,  132,    3,  323,  242,  243,  244,  216,   45,
   91,  303,  139,  217,  132,    4,    5,  292,  286,   93,
  339,  170,  144,  171,   94,  153,  168,  253,   46,  213,
  266,  297,  139,  170,  132,  327,  155,   95,   96,   97,
   98,   99,  100,  101,  102,   22,  310,  311,  104,  105,
  106,  107,  108,  109,  110,  319,  168,  338,  177,  215,
  144,  177,    6,    7,  343,  221,   41,  330,  168,   75,
   54,  185,  214,  216,  155,  348,  178,  221,  224,   51,
   89,   90,  290,  291,  280,  185,  185,  185,  185,  185,
  185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
  222,   75,  182,  265,  178,   75,  161,  178,   91,   92,
  224,  185,  222,  222,   75,   75,  267,   93,   56,   75,
   75,   75,   94,   75,   75,  185,  186,  187,  183,    6,
  185,  185,   65,  182,  185,   95,   96,   97,   98,   99,
  100,  101,  102,  103,  185,  222,  104,  105,  106,  107,
  108,  109,  110,  167,   17,  169,  167,   46,  169,  183,
   46,  147,  147,  179,   65,  147,    7,   17,   65,   46,
   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
   46,   46,   46,   46,   46,   46,   48,   65,  167,   48,
  169,  179,   46,   57,  179,   46,   46,   46,   48,   48,
   48,   48,   48,   48,   48,   48,   48,   48,   48,   48,
   48,   48,   48,   48,   48,  317,   46,   46,    6,  320,
   46,   48,  293,  336,  294,   48,   48,   69,  305,   74,
   46,  308,   84,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  173,   48,   48,  185,   68,   48,
  342,   76,  174,  329,   47,   48,   89,   90,  218,   48,
  328,  185,  185,  185,  185,  185,  185,  185,  185,  185,
  185,  185,  185,  185,  185,  185,  225,  335,  227,   50,
   48,   24,   67,   48,   91,  147,  148,  185,  179,  180,
  225,  346,  227,   93,   24,   81,   29,   29,   94,   83,
  137,  137,   82,  190,  191,    6,  185,  185,  192,   87,
  185,   95,   96,   97,   98,   99,  100,  101,  102,   22,
  185,  136,  104,  105,  106,  107,  108,  109,  110,  137,
   29,  142,  137,  341,  137,   29,  166,  345,  137,  137,
  181,  182,  183,  184,  347,  188,  189,   29,  237,  238,
  239,  137,   26,   27,   28,   29,   30,   31,   32,   33,
   34,   35,   36,   37,   38,   39,   40,   29,   55,   57,
  172,  137,  233,  234,  235,  236,  231,  232,   76,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   45,  240,  241,  175,    6,    7,  176,
  195,  208,  177,  178,  197,   45,  198,  199,  217,  201,
  200,  209,   26,   27,   28,   29,   30,   31,   32,   33,
   34,   35,   36,  207,   45,  220,  223,  245,   45,  251,
  252,  257,  254,  268,  259,  262,  269,  115,   45,  270,
  115,  115,  271,  273,  272,  115,  115,  115,  281,  286,
  288,  303,  295,  307,  316,  332,  313,    6,  315,   48,
  112,  112,  112,  334,  314,  340,  112,  112,  112,  180,
  134,  136,  115,  160,   58,  115,  115,  115,  115,  115,
  115,  115,  115,  219,  115,  115,  115,  115,   73,  115,
  115,  115,  112,  115,  223,   55,  112,  112,  112,  112,
  112,  112,  112,  112,  181,  112,  112,  112,  112,   89,
  112,  112,  112,  162,  112,  112,   89,   89,  225,  227,
   73,  230,  228,  318,   73,  229,  312,  151,  152,  196,
   90,  153,  246,   73,   73,  212,  279,   90,   90,   73,
   73,   89,   73,   73,  206,   89,   89,   89,   89,   89,
   89,   89,   89,  146,   89,   89,   89,   89,   85,   89,
   89,   89,   90,   89,   89,  145,   90,   90,   90,   90,
   90,   90,   90,   90,   80,   90,   90,   90,   90,   91,
   90,   90,   90,  144,   90,   90,   91,   91,  331,    0,
   85,    0,    0,    0,   85,   85,   85,   85,   85,   85,
   85,   85,    0,   85,   85,   85,   85,   86,   85,   85,
   85,   91,   85,   85,    0,   91,   91,   91,   91,   91,
   91,   91,   91,    0,   91,   91,   91,   91,   88,   91,
   91,   91,    0,   91,   91,    0,    0,    0,    0,   86,
    0,    0,    0,   86,   86,   86,   86,   86,   86,   86,
   86,    0,   86,   86,   86,   86,   87,   86,   86,   86,
   88,   86,   86,    0,   88,   88,   88,   88,   88,   88,
   88,   88,    0,   88,   88,   88,   88,   80,   88,   88,
   88,    0,   88,   88,    0,    0,    0,    0,   87,    0,
    0,    0,   87,   87,   87,   87,   87,   87,   87,   87,
    0,   87,   87,   87,   87,   83,   87,   87,   87,   80,
   87,   87,    0,   80,   80,   80,   80,   80,    0,    0,
    0,    0,   80,   80,   80,   80,   84,   80,   80,   80,
    0,   80,   80,    0,    0,    0,    0,   83,    0,    0,
    0,   83,   83,   83,   83,   83,    0,   81,    0,    0,
   83,   83,   83,   83,    0,   83,   83,   83,   84,   83,
   83,    0,   84,   84,   84,   84,   84,    0,   82,    0,
    0,   84,   84,   84,   84,    0,   84,   84,   84,   81,
   84,   84,    0,   81,   81,   81,   81,   81,    0,   77,
    0,    0,   81,   81,   81,   81,    0,   81,   81,   81,
   82,   81,   81,    0,   82,   82,   82,   82,   82,    0,
   78,    0,    0,   82,   82,   82,   82,    0,   82,   82,
   82,   77,   82,   82,    0,   77,    0,   79,    0,    0,
    0,    0,    0,    0,   77,   77,   77,   77,    0,   77,
   77,   77,   78,   77,   77,    0,   78,    0,   76,    0,
    0,    0,    0,    0,    0,   78,   78,   78,   78,   79,
   78,   78,   78,   79,   78,   78,    0,    0,    0,   74,
    0,    0,   79,   79,   79,   79,    0,   79,   79,   79,
   76,   79,   79,    0,   76,    0,   71,    0,    0,    0,
    0,    0,    0,   76,   76,    0,    0,   72,   76,   76,
   76,   74,   76,   76,    0,   74,    0,    0,    0,    0,
    0,    0,    0,   69,   74,   74,    0,    0,   71,    0,
   74,   74,   71,   74,   74,   70,    0,    0,   67,   72,
   68,   71,   71,   72,    0,    0,    0,   71,    0,    0,
   71,   71,   72,   72,    0,   69,    0,    0,   72,   69,
    0,   72,   72,    0,    0,    0,    0,   70,   69,   69,
   67,   70,   68,    0,   67,    0,   68,   69,   69,    0,
   70,   70,    0,    0,   67,    0,   68,    0,    0,   70,
   70,    0,   67,   67,   68,   68,  112,  112,    0,    0,
    0,  112,  112,  112,    0,   26,   27,   28,   29,   30,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  112,  112,  112,  112,  112,  112,  112,   91,
  112,  112,  112,  112,    0,  112,  112,  112,   93,  112,
    6,    7,    0,   94,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   95,   96,   97,   98,
   99,  100,  101,  102,   22,    0,    0,  104,  105,  106,
  107,  108,  109,  110,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   45,
};
final static short yycheck[] = {                          2,
    0,   74,  211,   91,   89,   90,  153,    6,   93,   94,
  166,  257,  261,  282,  288,    2,  274,  291,  257,  257,
  260,    5,  258,  259,  260,  257,  257,  257,   15,    0,
  260,  260,  330,  258,  318,  257,   20,  257,  260,  195,
  258,  257,   45,  314,  260,  257,  292,  331,  260,  213,
  257,  330,  288,  260,  292,  291,   59,  293,  298,  330,
  258,  330,  298,  259,  260,  212,  296,  296,  293,  142,
  316,  293,  330,  295,  310,  293,   63,  295,  317,  297,
   83,  330,  267,  268,  330,   88,  174,  260,  320,  320,
  320,  258,   91,   80,  330,  293,  305,  295,  320,  297,
  320,  265,  298,  257,  320,  190,  191,  192,  320,  291,
  295,  286,  330,  320,  310,  269,  270,  273,  293,  304,
  329,  258,  260,  112,  309,  298,  293,  200,  291,  296,
  215,  278,  330,  258,  330,  306,  260,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  293,  294,  333,  334,
  335,  336,  337,  338,  339,  302,  293,  328,  288,  296,
  298,  291,  316,  317,  335,  258,  153,  314,  293,  260,
  332,  257,  161,  162,  298,  346,  260,  258,  258,  258,
  267,  268,  267,  271,  257,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  293,  292,  260,  296,  288,  296,  292,  291,  295,  296,
  258,  297,  293,  293,  305,  306,  296,  304,  330,  310,
  311,  312,  309,  314,  315,  301,  302,  303,  260,  316,
  316,  317,  260,  291,  320,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  330,  293,  333,  334,  335,  336,
  337,  338,  339,  257,  318,  257,  260,  257,  260,  291,
  260,  287,  288,  260,  292,  291,  317,  331,  296,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  257,  315,  292,  260,
  292,  288,  292,  330,  291,  295,  296,  297,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  302,  316,  317,  316,  303,
  320,  292,  287,  326,  289,  296,  297,  295,  284,  288,
  330,  287,  330,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  306,  316,  317,  257,  330,  320,
  334,  297,  314,  309,  257,  258,  267,  268,  296,  330,
  308,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  316,  325,  316,  257,
  258,  318,  257,  258,  295,  320,  321,  297,  307,  308,
  330,  339,  330,  304,  331,  292,  259,  260,  309,  260,
  259,  260,  257,  261,  262,  316,  316,  317,  266,  292,
  320,  322,  323,  324,  325,  326,  327,  328,  329,  330,
  330,  330,  333,  334,  335,  336,  337,  338,  339,  288,
  293,  287,  291,  333,  293,  298,  263,  337,  297,  298,
  297,  298,  299,  300,  344,  267,  268,  310,  185,  186,
  187,  310,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  330,  291,  292,
  296,  330,  181,  182,  183,  184,  179,  180,  297,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  188,  189,  305,  316,  317,  311,
  291,  320,  312,  310,  297,  297,  258,  258,  296,  330,
  260,  330,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  320,  316,  294,  282,  330,  320,  330,
  330,  260,  287,  282,  330,  330,  294,  258,  330,  282,
  261,  262,  315,  260,  292,  266,  267,  268,  295,  293,
  330,  286,  260,  294,  260,  259,  298,  316,  296,  258,
  260,  261,  262,  260,  310,  330,  266,  267,  268,  291,
  298,  330,  293,  292,  292,  296,  297,  298,  299,  300,
  301,  302,  303,  296,  305,  306,  307,  308,  260,  310,
  311,  312,  292,  314,  330,  291,  296,  297,  298,  299,
  300,  301,  302,  303,  291,  305,  306,  307,  308,  260,
  310,  311,  312,   91,  314,  315,  267,  268,  173,  175,
  292,  178,  176,  302,  296,  177,  295,   88,   88,  135,
  260,   88,  193,  305,  306,  153,  255,  267,  268,  311,
  312,  292,  314,  315,  143,  296,  297,  298,  299,  300,
  301,  302,  303,   83,  305,  306,  307,  308,  260,  310,
  311,  312,  292,  314,  315,   82,  296,  297,  298,  299,
  300,  301,  302,  303,   59,  305,  306,  307,  308,  260,
  310,  311,  312,   80,  314,  315,  267,  268,  316,   -1,
  292,   -1,   -1,   -1,  296,  297,  298,  299,  300,  301,
  302,  303,   -1,  305,  306,  307,  308,  260,  310,  311,
  312,  292,  314,  315,   -1,  296,  297,  298,  299,  300,
  301,  302,  303,   -1,  305,  306,  307,  308,  260,  310,
  311,  312,   -1,  314,  315,   -1,   -1,   -1,   -1,  292,
   -1,   -1,   -1,  296,  297,  298,  299,  300,  301,  302,
  303,   -1,  305,  306,  307,  308,  260,  310,  311,  312,
  292,  314,  315,   -1,  296,  297,  298,  299,  300,  301,
  302,  303,   -1,  305,  306,  307,  308,  260,  310,  311,
  312,   -1,  314,  315,   -1,   -1,   -1,   -1,  292,   -1,
   -1,   -1,  296,  297,  298,  299,  300,  301,  302,  303,
   -1,  305,  306,  307,  308,  260,  310,  311,  312,  292,
  314,  315,   -1,  296,  297,  298,  299,  300,   -1,   -1,
   -1,   -1,  305,  306,  307,  308,  260,  310,  311,  312,
   -1,  314,  315,   -1,   -1,   -1,   -1,  292,   -1,   -1,
   -1,  296,  297,  298,  299,  300,   -1,  260,   -1,   -1,
  305,  306,  307,  308,   -1,  310,  311,  312,  292,  314,
  315,   -1,  296,  297,  298,  299,  300,   -1,  260,   -1,
   -1,  305,  306,  307,  308,   -1,  310,  311,  312,  292,
  314,  315,   -1,  296,  297,  298,  299,  300,   -1,  260,
   -1,   -1,  305,  306,  307,  308,   -1,  310,  311,  312,
  292,  314,  315,   -1,  296,  297,  298,  299,  300,   -1,
  260,   -1,   -1,  305,  306,  307,  308,   -1,  310,  311,
  312,  292,  314,  315,   -1,  296,   -1,  260,   -1,   -1,
   -1,   -1,   -1,   -1,  305,  306,  307,  308,   -1,  310,
  311,  312,  292,  314,  315,   -1,  296,   -1,  260,   -1,
   -1,   -1,   -1,   -1,   -1,  305,  306,  307,  308,  292,
  310,  311,  312,  296,  314,  315,   -1,   -1,   -1,  260,
   -1,   -1,  305,  306,  307,  308,   -1,  310,  311,  312,
  292,  314,  315,   -1,  296,   -1,  260,   -1,   -1,   -1,
   -1,   -1,   -1,  305,  306,   -1,   -1,  260,  310,  311,
  312,  292,  314,  315,   -1,  296,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  260,  305,  306,   -1,   -1,  292,   -1,
  311,  312,  296,  314,  315,  260,   -1,   -1,  260,  292,
  260,  305,  306,  296,   -1,   -1,   -1,  311,   -1,   -1,
  314,  315,  305,  306,   -1,  292,   -1,   -1,  311,  296,
   -1,  314,  315,   -1,   -1,   -1,   -1,  292,  305,  306,
  292,  296,  292,   -1,  296,   -1,  296,  314,  315,   -1,
  305,  306,   -1,   -1,  306,   -1,  306,   -1,   -1,  314,
  315,   -1,  314,  315,  314,  315,  261,  262,   -1,   -1,
   -1,  266,  267,  268,   -1,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  297,  298,  299,  300,  301,  302,  303,  295,
  305,  306,  307,  308,   -1,  310,  311,  312,  304,  314,
  316,  317,   -1,  309,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  322,  323,  324,  325,
  326,  327,  328,  329,  330,   -1,   -1,  333,  334,  335,
  336,  337,  338,  339,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,
};
final static short YYFINAL=1;
final static short YYMAXTOKEN=339;
final static String yyname[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,"SEMI","DOT","DOTDOTDOT","COMMA","STAR","PERCENT","EQUALS",
"ANNOSTRING","ANNOCHAR","SLASH","PLUS","MINUS","PACKAGE","IMPORT","PUBLIC",
"PROTECTED","PRIVATE","STATIC","FINAL","ABSTRACT","NATIVE","STRICTFP",
"SYNCHRONIZED","TRANSIENT","VOLATILE","CLASS","INTERFACE","ENUM",
"ANNOINTERFACE","THROWS","EXTENDS","IMPLEMENTS","SUPER","DEFAULT","BRACEOPEN",
"BRACECLOSE","SQUAREOPEN","SQUARECLOSE","PARENOPEN","PARENCLOSE","LESSTHAN",
"GREATERTHAN","LESSEQUALS","GREATEREQUALS","LESSTHAN2","GREATERTHAN2",
"GREATERTHAN3","EXCLAMATION","AMPERSAND2","VERTLINE2","EQUALS2","NOTEQUALS",
"TILDE","AMPERSAND","VERTLINE","CIRCUMFLEX","VOID","QUERY","COLON","AT",
"JAVADOCSTART","JAVADOCEND","JAVADOCEOL","CODEBLOCK","PARENBLOCK","BYTE",
"SHORT","INT","LONG","CHAR","FLOAT","DOUBLE","BOOLEAN","IDENTIFIER",
"JAVADOCTAG","JAVADOCLINE","BOOLEAN_LITERAL","INTEGER_LITERAL","LONG_LITERAL",
"FLOAT_LITERAL","DOUBLE_LITERAL","CHAR_LITERAL","STRING_LITERAL",
};
final static String yyrule[] = {
"$accept : file",
"file :",
"$$1 :",
"file : file $$1 filepart",
"filepart : annotation",
"filepart : package",
"filepart : import",
"filepart : javadoc",
"filepart : class",
"filepart : enum",
"filepart : SEMI",
"package : PACKAGE fullidentifier SEMI",
"import : IMPORT fullidentifier SEMI",
"import : IMPORT STATIC fullidentifier SEMI",
"javadoclist : javadoc",
"javadoclist : javadoclist javadoc",
"javadoc : JAVADOCSTART javadocdescription javadoctags JAVADOCEND",
"javadocdescription : javadoctokens",
"javadoctokens :",
"javadoctokens : javadoctokens javadoctoken",
"javadoctoken : JAVADOCLINE",
"javadoctags :",
"javadoctags : javadoctags javadoctag",
"$$2 :",
"javadoctag : JAVADOCTAG $$2 javadoctokens",
"fullidentifier : IDENTIFIER",
"fullidentifier : fullidentifier DOT IDENTIFIER",
"fullidentifier : fullidentifier DOT STAR",
"arrayidentifier : IDENTIFIER dimensions",
"dimensions :",
"dimensions : dimensions SQUAREOPEN SQUARECLOSE",
"modifier : PUBLIC",
"modifier : PROTECTED",
"modifier : PRIVATE",
"modifier : STATIC",
"modifier : FINAL",
"modifier : ABSTRACT",
"modifier : NATIVE",
"modifier : SYNCHRONIZED",
"modifier : VOLATILE",
"modifier : TRANSIENT",
"modifier : STRICTFP",
"modifiers : modifiers modifier",
"modifiers : modifiers annotation",
"modifiers : modifiers javadoc",
"modifiers :",
"$$3 :",
"annotation : AT name $$3 annotationParensOpt",
"annotationParensOpt :",
"annotationParensOpt : PARENOPEN value PARENCLOSE",
"annotationParensOpt : PARENOPEN valuePairs PARENCLOSE",
"annotationParensOpt : PARENOPEN PARENCLOSE",
"valuePairs : valuePair",
"valuePairs : valuePairs COMMA valuePair",
"valuePair : IDENTIFIER EQUALS value",
"$$4 :",
"arrayInitializer : $$4 BRACEOPEN valuesOpt BRACECLOSE",
"valuesOpt :",
"valuesOpt : values",
"values : value",
"values : values COMMA value",
"value : expression",
"value : annotation",
"value : arrayInitializer",
"expression : conditionalExpression",
"conditionalExpression : conditionalOrExpression",
"conditionalExpression : conditionalOrExpression QUERY expression COLON expression",
"conditionalOrExpression : conditionalAndExpression",
"conditionalOrExpression : conditionalOrExpression VERTLINE2 conditionalAndExpression",
"conditionalAndExpression : inclusiveOrExpression",
"conditionalAndExpression : conditionalAndExpression AMPERSAND2 inclusiveOrExpression",
"inclusiveOrExpression : exclusiveOrExpression",
"inclusiveOrExpression : inclusiveOrExpression VERTLINE exclusiveOrExpression",
"exclusiveOrExpression : andExpression",
"exclusiveOrExpression : exclusiveOrExpression CIRCUMFLEX andExpression",
"andExpression : equalityExpression",
"andExpression : andExpression AMPERSAND equalityExpression",
"equalityExpression : relationalExpression",
"equalityExpression : equalityExpression EQUALS2 relationalExpression",
"equalityExpression : equalityExpression NOTEQUALS relationalExpression",
"relationalExpression : shiftExpression",
"relationalExpression : relationalExpression LESSEQUALS shiftExpression",
"relationalExpression : relationalExpression GREATEREQUALS shiftExpression",
"relationalExpression : relationalExpression LESSTHAN shiftExpression",
"relationalExpression : relationalExpression GREATERTHAN shiftExpression",
"shiftExpression : additiveExpression",
"shiftExpression : shiftExpression LESSTHAN2 additiveExpression",
"shiftExpression : shiftExpression GREATERTHAN3 additiveExpression",
"shiftExpression : shiftExpression GREATERTHAN2 additiveExpression",
"additiveExpression : multiplicativeExpression",
"additiveExpression : additiveExpression PLUS multiplicativeExpression",
"additiveExpression : additiveExpression MINUS multiplicativeExpression",
"multiplicativeExpression : unaryExpression",
"multiplicativeExpression : multiplicativeExpression STAR unaryExpression",
"multiplicativeExpression : multiplicativeExpression SLASH unaryExpression",
"multiplicativeExpression : multiplicativeExpression PERCENT unaryExpression",
"unaryExpression : PLUS unaryExpression",
"unaryExpression : MINUS unaryExpression",
"unaryExpression : unaryExpressionNotPlusMinus",
"unaryExpressionNotPlusMinus : TILDE unaryExpression",
"unaryExpressionNotPlusMinus : EXCLAMATION unaryExpression",
"unaryExpressionNotPlusMinus : primary",
"primary : PARENOPEN primitiveType PARENCLOSE unaryExpression",
"primary : PARENOPEN primitiveType dims PARENCLOSE unaryExpression",
"primary : PARENOPEN name dims PARENCLOSE unaryExpressionNotPlusMinus",
"primary : PARENOPEN name PARENCLOSE unaryExpressionNotPlusMinus",
"primary : PARENOPEN expression PARENCLOSE",
"primary : literal",
"primary : primitiveType dims DOT CLASS",
"primary : primitiveType DOT CLASS",
"primary : name DOT CLASS",
"primary : name dims DOT CLASS",
"primary : name",
"dims : SQUAREOPEN SQUARECLOSE",
"dims : dims SQUAREOPEN SQUARECLOSE",
"name : IDENTIFIER",
"name : name DOT IDENTIFIER",
"literal : DOUBLE_LITERAL",
"literal : FLOAT_LITERAL",
"literal : LONG_LITERAL",
"literal : INTEGER_LITERAL",
"literal : BOOLEAN_LITERAL",
"literal : CHAR_LITERAL",
"literal : STRING_LITERAL",
"primitiveType : BOOLEAN",
"primitiveType : BYTE",
"primitiveType : SHORT",
"primitiveType : INT",
"primitiveType : LONG",
"primitiveType : CHAR",
"primitiveType : FLOAT",
"primitiveType : DOUBLE",
"type : classtype dimensions",
"$$5 :",
"$$6 :",
"classtype : typedeclspecifier LESSTHAN $$5 typearglist $$6 GREATERTHAN",
"classtype : typedeclspecifier",
"typedeclspecifier : typename",
"typedeclspecifier : classtype DOT IDENTIFIER",
"typename : IDENTIFIER",
"typename : typename DOT IDENTIFIER",
"typearglist : typearg",
"typearglist : typearglist COMMA typearg",
"typearg : type",
"typearg : QUERY",
"typearg : QUERY EXTENDS type",
"typearg : QUERY SUPER type",
"opt_typeparams :",
"opt_typeparams : typeparams",
"$$7 :",
"typeparams : LESSTHAN $$7 typeparamlist GREATERTHAN",
"typeparamlist : typeparam",
"typeparamlist : typeparamlist COMMA typeparam",
"typeparam : IDENTIFIER",
"$$8 :",
"typeparam : IDENTIFIER EXTENDS $$8 typeboundlist",
"typeboundlist : type",
"typeboundlist : typeboundlist AMPERSAND type",
"enum : enum_definition BRACEOPEN enum_body BRACECLOSE",
"enum_definition : modifiers ENUM IDENTIFIER opt_implements",
"enum_body : enum_values",
"enum_body : enum_values SEMI members",
"enum_values :",
"enum_values : enum_value",
"enum_values : enum_value COMMA enum_values",
"enum_value : javadoclist opt_annotations enum_constructor",
"enum_value : opt_annotations enum_constructor",
"enum_constructor : IDENTIFIER",
"enum_constructor : IDENTIFIER CODEBLOCK",
"enum_constructor : IDENTIFIER PARENBLOCK",
"enum_constructor : IDENTIFIER PARENBLOCK CODEBLOCK",
"class : classdefinition BRACEOPEN members BRACECLOSE",
"classdefinition : modifiers classorinterface IDENTIFIER opt_typeparams opt_extends opt_implements",
"classorinterface : CLASS",
"classorinterface : INTERFACE",
"classorinterface : ANNOINTERFACE",
"opt_extends :",
"opt_extends : EXTENDS extendslist",
"extendslist : classtype",
"extendslist : extendslist COMMA classtype",
"opt_implements :",
"opt_implements : IMPLEMENTS implementslist",
"implementslist : classtype",
"implementslist : implementslist COMMA classtype",
"members :",
"$$9 :",
"members : members $$9 member",
"member : javadoc",
"member : fields",
"member : method",
"member : constructor",
"member : static_block",
"member : class",
"member : enum",
"member : SEMI",
"memberend : SEMI",
"memberend : CODEBLOCK",
"static_block : modifiers CODEBLOCK",
"$$10 :",
"fields : modifiers type arrayidentifier $$10 extrafields memberend",
"extrafields :",
"$$11 :",
"extrafields : extrafields COMMA $$11 arrayidentifier",
"$$12 :",
"extrafields : extrafields COMMA javadoc $$12 arrayidentifier",
"$$13 :",
"method : modifiers typeparams type IDENTIFIER $$13 methoddef dimensions opt_exceptions memberend",
"$$14 :",
"method : modifiers type IDENTIFIER $$14 methoddef dimensions opt_exceptions memberend",
"$$15 :",
"constructor : modifiers IDENTIFIER $$15 methoddef opt_exceptions memberend",
"$$16 :",
"constructor : modifiers typeparams IDENTIFIER $$16 methoddef opt_exceptions memberend",
"methoddef : PARENOPEN opt_params PARENCLOSE",
"opt_exceptions :",
"opt_exceptions : THROWS exceptionlist",
"exceptionlist : fullidentifier",
"exceptionlist : exceptionlist COMMA fullidentifier",
"opt_params :",
"opt_params : paramlist",
"paramlist : param",
"paramlist : paramlist COMMA param",
"param : opt_parammodifiers type varargs arrayidentifier",
"varargs :",
"varargs : DOTDOTDOT",
"opt_annotations :",
"opt_annotations : opt_annotations annotation",
"opt_parammodifiers :",
"opt_parammodifiers : opt_parammodifiers modifier",
"opt_parammodifiers : opt_parammodifiers annotation",
};

//#line 558 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"

private Lexer lexer;
private Builder builder;
private StringBuffer textBuffer = new StringBuffer();
private ClassDef cls = new ClassDef();
private MethodDef mth = new MethodDef();
private List typeParams = new ArrayList(); //for both JavaClass and JavaMethod
private List annotationStack = new ArrayList(); // Use ArrayList intead of Stack because it is unsynchronized 
private Annotation annotation = null;
private List annoValueListStack = new ArrayList(); // Use ArrayList intead of Stack because it is unsynchronized
private List annoValueList = null;
private FieldDef param = new FieldDef();
private java.util.Set modifiers = new java.util.HashSet();
private TypeDef fieldType;
private TypeVariableDef typeVariable;
private Stack typeStack = new Stack();
private int line;
private int column;
private boolean debugLexer;

private void appendToBuffer(String word) {
    if (textBuffer.length() > 0) {
        char lastChar = textBuffer.charAt(textBuffer.length() - 1);
        if (!Character.isWhitespace(lastChar)) {
            textBuffer.append(' ');
        }
    }
    textBuffer.append(word);
}

private String buffer() {
    String result = textBuffer.toString().trim();
    textBuffer.setLength(0);
    return result;
}

public Parser(Lexer lexer, Builder builder) {
    this.lexer = lexer;
    this.builder = builder;
}

public void setDebugParser(boolean debug) {
    yydebug = debug;
}

public void setDebugLexer(boolean debug) {
    debugLexer = debug;
}

/**
 * Parse file. Return true if successful.
 */
public boolean parse() {
    return yyparse() == 0;
}

private int yylex() {
    try {
        final int result = lexer.lex();
        yylval = new Value();
        yylval.sval = lexer.text();
        if (debugLexer) {
            System.err.println("Token: " + yyname[result] + " \"" + yylval.sval + "\"");
        }
        return result;
    }
    catch(IOException e) {
        return 0;
    }
}

private void yyerror(String msg) {
    throw new ParseException(msg, lexer.getLine(), lexer.getColumn());
}

private class Value {
	Object oval;
    String sval;
    int ival;
	boolean bval;
    TypeDef type;
    AnnotationValue annoval;
}


private void makeField(TypeDef field, String body) {
    FieldDef fd = new FieldDef();
    fd.lineNumber = line;
    fd.modifiers.addAll(modifiers); 
    fd.name = field.name;
    fd.type = fieldType;
    fd.dimensions = field.dimensions;
    fd.body = body;
    builder.addField(fd);
}

private String convertString(String str) {
	StringBuffer buf = new StringBuffer();
	boolean escaped = false;
	int unicode = 0;
	int value = 0;
	int octal = 0;
	boolean consumed = false;
	
	for(int i = 0; i < str.length(); ++ i) {
		char ch = str.charAt( i );
		
		if(octal > 0) {
			if( value >= '0' && value <= '7' ) {
				value = ( value << 3 ) | Character.digit( ch, 8 );
				-- octal;
				consumed = true;
			}
			else {
				octal = 0;
			}
			
			if( octal == 0 ) {
				buf.append( (char) value );		
				value = 0;
			}
		}
		
		if(!consumed) {
			if(unicode > 0) {
				value = ( value << 4 ) | Character.digit( ch, 16 );
				
				-- unicode;
		
				if(unicode == 0) {
					buf.append( (char)value );
					value = 0;
				}
			}
			else if(ch == '\\') {
				escaped = true;
			}
			else if(escaped) {
				if(ch == 'u' || ch == 'U') {
					unicode = 4;
				}
				else if(ch >= '0' && ch <= '7') {
					octal = (ch > '3') ? 1 : 2;
					value = Character.digit( ch, 8 );
				}
				else {
					switch( ch ) {
						case 'b':
							buf.append('\b');
							break;
							
						case 'f':
							buf.append('\f');
							break;
							
						case 'n':
							buf.append('\n');
							break;
							
						case 'r':
							buf.append('\r');
							break;
							
						case 't':
							buf.append('\t');
							break;
							
						case '\'':
							buf.append('\'');
							break;
	
						case '\"':
							buf.append('\"');
							break;
	
						case '\\':
							buf.append('\\');
							break;
							
						default:
							yyerror( "Illegal escape character '" + ch + "'" );
					}
				}
				
				escaped = false;
			}
			else {
				buf.append( ch );
			}
		}
	}

	return buf.toString();
}

private Boolean toBoolean(String str) {
	str = str.trim();

	return new Boolean( str );
}

private Integer toInteger(String str) {
	str = str.trim();
	
	Integer result;
	
	if(str.startsWith("0x") || str.startsWith( "0X" ) ) {
		result = new Integer( Integer.parseInt( str.substring( 2 ), 16 ) );
	}
	else if(str.length() > 1 && str.startsWith("0") ) {
		result = new Integer( Integer.parseInt( str.substring( 1 ), 8 ) );
	}
	else {
		result = new Integer( str );
	}
	
	return result;
}

private Long toLong(String str) {
	str = str.trim();

	Long result;
	
	if( !str.endsWith("l") && !str.endsWith("L") ) {
		yyerror( "Long literal must end with 'l' or 'L'." );
	}
	
	int len = str.length() - 1;
	
	if(str.startsWith("0x") || str.startsWith( "0X" ) ) {
		result = new Long( Long.parseLong( str.substring( 2, len ), 16 ) );
	}
	else if(str.startsWith("0") ) {
		result = new Long( Long.parseLong( str.substring( 1, len ), 8 ) );
	}
	else {
		result = new Long( str.substring( 0, len ) );
	}

	return result;
}

private Float toFloat(String str) {
	str = str.trim();
	return new Float( str );
}

private Double toDouble(String str) {
	str = str.trim();

	if( !str.endsWith("d") && !str.endsWith("D") ) {
		yyerror( "Double literal must end with 'd' or 'D'." );
	}
	
	return new Double( str.substring( 0, str.length() - 1 ) );
}

/**
 * Convert a character literal into a character.
 */
private Character toChar(String str) {
	str = str.trim();

	if( !str.startsWith("'") && !str.endsWith("'") ) {
		yyerror("Character must be single quoted.");
	}

	String str2 = convertString( str.substring( 1, str.length() - 1 ) );
	
	if( str2.length() != 1) {
		yyerror("Only one character allowed in character constants.");
	}
	
	return new Character( str2.charAt( 0 ) );
}

/**
 * Convert a string literal into a string.
 */
private String toString(String str) {
	str = str.trim();

	if( str.length() < 2 && !str.startsWith("\"") && !str.endsWith("\"") ) {
		yyerror("String must be double quoted.");
	}

	String str2 = convertString( str.substring( 1, str.length() - 1 ) );
	return str2;
}
//#line 1183 "Parser.java"
//###############################################################
// method: yylexdebug : check lexer state
//###############################################################
void yylexdebug(int state,int ch)
{
String s=null;
  if (ch < 0) ch=0;
  if (ch <= YYMAXTOKEN) //check index bounds
     s = yyname[ch];    //now get it
  if (s==null)
    s = "illegal-symbol";
  debug("state "+state+", reading "+ch+" ("+s+")");
}





//The following are now global, to aid in error reporting
int yyn;       //next next thing to do
int yym;       //
int yystate;   //current parsing state from state table
String yys;    //current token string


//###############################################################
// method: yyparse : parse input and execute indicated items
//###############################################################
int yyparse()
{
boolean doaction;
  init_stacks();
  yynerrs = 0;
  yyerrflag = 0;
  yychar = -1;          //impossible char forces a read
  yystate=0;            //initial state
  state_push(yystate);  //save it
  while (true) //until parsing is done, either correctly, or w/error
    {
    doaction=true;
    if (yydebug) debug("loop"); 
    //#### NEXT ACTION (from reduction table)
    for (yyn=yydefred[yystate];yyn==0;yyn=yydefred[yystate])
      {
      if (yydebug) debug("yyn:"+yyn+"  state:"+yystate+"  yychar:"+yychar);
      if (yychar < 0)      //we want a char?
        {
        yychar = yylex();  //get next token
        if (yydebug) debug(" next yychar:"+yychar);
        //#### ERROR CHECK ####
        if (yychar < 0)    //it it didn't work/error
          {
          yychar = 0;      //change it to default string (no -1!)
          if (yydebug)
            yylexdebug(yystate,yychar);
          }
        }//yychar<0
      yyn = yysindex[yystate];  //get amount to shift by (shift index)
      if ((yyn != 0) && (yyn += yychar) >= 0 &&
          yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
        {
        if (yydebug)
          debug("state "+yystate+", shifting to state "+yytable[yyn]);
        //#### NEXT STATE ####
        yystate = yytable[yyn];//we are in a new state
        state_push(yystate);   //save it
        val_push(yylval);      //push our lval as the input for next rule
        yychar = -1;           //since we have 'eaten' a token, say we need another
        if (yyerrflag > 0)     //have we recovered an error?
           --yyerrflag;        //give ourselves credit
        doaction=false;        //but don't process yet
        break;   //quit the yyn=0 loop
        }

    yyn = yyrindex[yystate];  //reduce
    if ((yyn !=0 ) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
      {   //we reduced!
      if (yydebug) debug("reduce");
      yyn = yytable[yyn];
      doaction=true; //get ready to execute
      break;         //drop down to actions
      }
    else //ERROR RECOVERY
      {
      if (yyerrflag==0)
        {
        yyerror("syntax error");
        yynerrs++;
        }
      if (yyerrflag < 3) //low error count?
        {
        yyerrflag = 3;
        while (true)   //do until break
          {
          if (stateptr<0)   //check for under & overflow here
            {
            yyerror("stack underflow. aborting...");  //note lower case 's'
            return 1;
            }
          yyn = yysindex[state_peek(0)];
          if ((yyn != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
            if (yydebug)
              debug("state "+state_peek(0)+", error recovery shifting to state "+yytable[yyn]+" ");
            yystate = yytable[yyn];
            state_push(yystate);
            val_push(yylval);
            doaction=false;
            break;
            }
          else
            {
            if (yydebug)
              debug("error recovery discarding state "+state_peek(0)+" ");
            if (stateptr<0)   //check for under & overflow here
              {
              yyerror("Stack underflow. aborting...");  //capital 'S'
              return 1;
              }
            state_pop();
            val_pop();
            }
          }
        }
      else            //discard this token
        {
        if (yychar == 0)
          return 1; //yyabort
        if (yydebug)
          {
          yys = null;
          if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
          if (yys == null) yys = "illegal-symbol";
          debug("state "+yystate+", error recovery discards token "+yychar+" ("+yys+")");
          }
        yychar = -1;  //read another
        }
      }//end error recovery
    }//yyn=0 loop
    if (!doaction)   //any reason not to proceed?
      continue;      //skip action
    yym = yylen[yyn];          //get count of terminals on rhs
    if (yydebug)
      debug("state "+yystate+", reducing "+yym+" by rule "+yyn+" ("+yyrule[yyn]+")");
    if (yym>0)                 //if count of rhs not 'nil'
      yyval = val_peek(yym-1); //get current semantic value
    switch(yyn)
      {
//########## USER-SUPPLIED ACTIONS ##########
case 2:
//#line 56 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 4:
//#line 59 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addAnnotation((Annotation) val_peek(0).annoval); }
break;
case 11:
//#line 62 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addPackage(new PackageDef(val_peek(1).sval, line)); }
break;
case 12:
//#line 65 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 13:
//#line 66 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 17:
//#line 78 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ 
        builder.addJavaDoc(buffer()); 
    }
break;
case 20:
//#line 85 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        appendToBuffer(val_peek(0).sval);
    }
break;
case 23:
//#line 92 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 24:
//#line 93 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        builder.addJavaDocTag(new TagDef(val_peek(2).sval.substring(1), buffer(), line)); 
    }
break;
case 25:
//#line 102 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 26:
//#line 103 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval; }
break;
case 27:
//#line 104 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + ".*"; }
break;
case 28:
//#line 107 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(1).sval,val_peek(0).ival);
    }
break;
case 29:
//#line 112 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.ival = 0; }
break;
case 30:
//#line 113 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        yyval.ival = val_peek(2).ival + 1; 
    }
break;
case 31:
//#line 119 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "public"; }
break;
case 32:
//#line 120 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "protected"; }
break;
case 33:
//#line 121 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "private"; }
break;
case 34:
//#line 122 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "static"; }
break;
case 35:
//#line 123 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "final"; }
break;
case 36:
//#line 124 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "abstract"; }
break;
case 37:
//#line 125 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "native"; }
break;
case 38:
//#line 126 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "synchronized"; }
break;
case 39:
//#line 127 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "volatile"; }
break;
case 40:
//#line 128 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "transient"; }
break;
case 41:
//#line 129 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "strictfp"; }
break;
case 42:
//#line 132 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ modifiers.add(val_peek(0).sval); }
break;
case 43:
//#line 133 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addAnnotation((Annotation) val_peek(0).annoval); }
break;
case 46:
//#line 144 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ 
    	annotationStack.add(annotation);
    	annotation = new Annotation(builder.createType(val_peek(0).sval, 0), lexer.getLine()); 
    }
break;
case 47:
//#line 149 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
    	yyval.annoval = annotation;
    	annotation = (Annotation)annotationStack.remove(annotationStack.size() - 1);
    }
break;
case 49:
//#line 156 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ annotation.setProperty("value", val_peek(1).annoval); }
break;
case 54:
//#line 165 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ annotation.setProperty(val_peek(2).sval, val_peek(0).annoval); }
break;
case 55:
//#line 168 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
    	annoValueListStack.add(annoValueList);
    	annoValueList = new ArrayList(); 
    }
break;
case 56:
//#line 173 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
    	yyval.annoval = new AnnotationValueList(annoValueList);
    	annoValueList = (List)annoValueListStack.remove(annoValueListStack.size() - 1);
    }
break;
case 59:
//#line 183 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ annoValueList.add(val_peek(0).annoval); }
break;
case 60:
//#line 184 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ annoValueList.add(val_peek(0).annoval); }
break;
case 61:
//#line 187 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 62:
//#line 188 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 63:
//#line 189 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 64:
//#line 192 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 65:
//#line 195 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 66:
//#line 196 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationQuery(val_peek(4).annoval, val_peek(2).annoval, val_peek(0).annoval); }
break;
case 67:
//#line 199 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 68:
//#line 200 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 69:
//#line 203 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 70:
//#line 204 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalAnd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 71:
//#line 207 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 72:
//#line 208 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 73:
//#line 211 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 74:
//#line 212 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationExclusiveOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 75:
//#line 215 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 76:
//#line 216 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationAnd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 77:
//#line 219 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 78:
//#line 220 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 79:
//#line 221 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationNotEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 80:
//#line 224 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 81:
//#line 225 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLessEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 82:
//#line 226 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationGreaterEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 83:
//#line 227 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLessThan(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 84:
//#line 228 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationGreaterThan(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 85:
//#line 231 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 86:
//#line 232 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationShiftLeft(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 87:
//#line 233 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationUnsignedShiftRight(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 88:
//#line 234 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationShiftRight(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 89:
//#line 237 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 90:
//#line 238 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationAdd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 91:
//#line 239 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationSubtract(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 92:
//#line 242 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 93:
//#line 243 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationMultiply(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 94:
//#line 244 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationDivide(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 95:
//#line 245 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationRemainder(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 96:
//#line 248 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationPlusSign(val_peek(0).annoval); }
break;
case 97:
//#line 249 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationMinusSign(val_peek(0).annoval); }
break;
case 98:
//#line 250 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 99:
//#line 253 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationNot(val_peek(0).annoval); }
break;
case 100:
//#line 254 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalNot(val_peek(0).annoval); }
break;
case 102:
//#line 258 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(2).sval, 0), val_peek(0).annoval); }
break;
case 103:
//#line 259 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(3).sval, val_peek(2).ival), val_peek(0).annoval); }
break;
case 104:
//#line 260 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(3).sval, val_peek(2).ival), val_peek(0).annoval); }
break;
case 105:
//#line 261 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(2).sval, 0), val_peek(0).annoval); }
break;
case 106:
//#line 262 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationParenExpression(val_peek(1).annoval); }
break;
case 107:
//#line 263 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 108:
//#line 264 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(3).sval, 0)); }
break;
case 109:
//#line 265 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(2).sval, 0)); }
break;
case 110:
//#line 266 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(2).sval, 0)); }
break;
case 111:
//#line 267 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(3).sval, 0)); }
break;
case 112:
//#line 268 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationFieldRef(val_peek(0).sval); }
break;
case 113:
//#line 271 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.ival = 1; }
break;
case 114:
//#line 272 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.ival = val_peek(2).ival + 1; }
break;
case 115:
//#line 275 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 116:
//#line 276 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + "." + val_peek(0).sval; }
break;
case 117:
//#line 279 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toDouble(val_peek(0).sval), val_peek(0).sval); }
break;
case 118:
//#line 280 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toFloat(val_peek(0).sval), val_peek(0).sval); }
break;
case 119:
//#line 281 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toLong(val_peek(0).sval), val_peek(0).sval); }
break;
case 120:
//#line 282 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toInteger(val_peek(0).sval), val_peek(0).sval); }
break;
case 121:
//#line 283 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toBoolean(val_peek(0).sval), val_peek(0).sval); }
break;
case 122:
//#line 284 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ String s = lexer.getCodeBody(); yyval.annoval = new AnnotationConstant(toChar(s), s); }
break;
case 123:
//#line 285 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ String s = lexer.getCodeBody(); yyval.annoval = new AnnotationConstant(toString(s), s); }
break;
case 124:
//#line 288 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "boolean"; }
break;
case 125:
//#line 289 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "byte"; }
break;
case 126:
//#line 290 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "short"; }
break;
case 127:
//#line 291 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "int"; }
break;
case 128:
//#line 292 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "long"; }
break;
case 129:
//#line 293 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "char"; }
break;
case 130:
//#line 294 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "float"; }
break;
case 131:
//#line 295 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "double"; }
break;
case 132:
//#line 301 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
    	TypeDef td = val_peek(1).type;
    	td.dimensions = val_peek(0).ival;
        yyval.type = td;
    }
break;
case 133:
//#line 308 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
    		TypeDef td = new TypeDef(val_peek(1).sval,0);
    		td.actualArgumentTypes = new ArrayList();
    		yyval.type = (TypeDef) typeStack.push(td);
    	}
break;
case 134:
//#line 312 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ 
    		yyval.type = (TypeDef) typeStack.pop();
    	}
break;
case 135:
//#line 314 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
         yyval.type = val_peek(1).type;
    }
break;
case 136:
//#line 317 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(0).sval,0); 
    }
break;
case 137:
//#line 322 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 138:
//#line 323 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).type.name + '.' + val_peek(0).sval; }
break;
case 139:
//#line 326 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 140:
//#line 327 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval; }
break;
case 141:
//#line 330 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ ((TypeDef) typeStack.peek()).actualArgumentTypes.add(val_peek(0).type);}
break;
case 142:
//#line 331 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ ((TypeDef) typeStack.peek()).actualArgumentTypes.add(val_peek(0).type);}
break;
case 143:
//#line 334 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.type = val_peek(0).type;}
break;
case 144:
//#line 335 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef();}
break;
case 145:
//#line 336 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef(val_peek(0).type, "extends");}
break;
case 146:
//#line 337 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef(val_peek(0).type, "super");}
break;
case 149:
//#line 341 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ typeParams = new ArrayList(); }
break;
case 153:
//#line 348 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ typeParams.add(new TypeVariableDef(val_peek(0).sval)); }
break;
case 154:
//#line 349 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ 
      typeVariable = new TypeVariableDef(val_peek(1).sval);
      typeVariable.bounds = new ArrayList();
    }
break;
case 155:
//#line 352 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
      typeParams.add(typeVariable);
      typeVariable = null;
    }
break;
case 156:
//#line 358 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ typeVariable.bounds.add(val_peek(0).type); }
break;
case 157:
//#line 359 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ typeVariable.bounds.add(val_peek(0).type); }
break;
case 158:
//#line 363 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
  builder.endClass();
  fieldType = null;
  modifiers.clear();
}
break;
case 159:
//#line 369 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
    cls.lineNumber = line;
    cls.modifiers.addAll(modifiers);
    cls.name = val_peek(1).sval;
    cls.type = ClassDef.ENUM;
    builder.beginClass(cls);
    cls = new ClassDef();
    fieldType = new TypeDef(val_peek(1).sval, 0);
}
break;
case 167:
//#line 388 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(0).sval, 0), ""); }
break;
case 168:
//#line 389 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(1).sval, 0), ""); }
break;
case 169:
//#line 390 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(1).sval, 0), ""); }
break;
case 170:
//#line 391 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(2).sval, 0), ""); }
break;
case 171:
//#line 397 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        builder.endClass(); 
    }
break;
case 172:
//#line 402 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        cls.lineNumber = line;
        cls.modifiers.addAll(modifiers); modifiers.clear(); 
        cls.name = val_peek(3).sval;
        cls.typeParams = typeParams;
        builder.beginClass(cls); 
        cls = new ClassDef(); 
    }
break;
case 173:
//#line 412 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.type = ClassDef.CLASS; }
break;
case 174:
//#line 413 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.type = ClassDef.INTERFACE; }
break;
case 175:
//#line 414 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.type = ClassDef.ANNOTATION_TYPE; }
break;
case 178:
//#line 419 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).type); }
break;
case 179:
//#line 420 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).type); }
break;
case 182:
//#line 425 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).type); }
break;
case 183:
//#line 426 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).type); }
break;
case 185:
//#line 428 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 195:
//#line 441 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
      yyval.sval = "";
    }
break;
case 196:
//#line 444 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
	  yyval.sval = lexer.getCodeBody();
    }
break;
case 197:
//#line 449 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ lexer.getCodeBody(); modifiers.clear(); }
break;
case 198:
//#line 454 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        fieldType = val_peek(1).type;
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 199:
//#line 458 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        modifiers.clear();
    }
break;
case 201:
//#line 463 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 202:
//#line 463 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 203:
//#line 466 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 204:
//#line 466 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 205:
//#line 474 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        builder.beginMethod();
        mth.typeParams = typeParams;
    }
break;
case 206:
//#line 477 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.returnType = val_peek(6).type;
        mth.dimensions = val_peek(2).ival;
        mth.name = val_peek(5).sval;
        mth.body = val_peek(0).sval;
        builder.endMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 207:
//#line 487 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
      builder.beginMethod();
    }
break;
case 208:
//#line 489 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear();
        mth.returnType = val_peek(6).type;
        mth.dimensions = val_peek(2).ival;
        mth.name = val_peek(5).sval;
        mth.body = val_peek(0).sval;
        builder.endMethod(mth);
        mth = new MethodDef();
    }
break;
case 209:
//#line 501 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        builder.beginMethod();
    }
break;
case 210:
//#line 503 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.constructor = true; mth.name = val_peek(4).sval;
        mth.body = val_peek(0).sval;
        builder.endMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 211:
//#line 511 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        builder.beginMethod();
        mth.typeParams = typeParams;
    }
break;
case 212:
//#line 514 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.constructor = true; mth.name = val_peek(4).sval;
        mth.body = val_peek(0).sval;
        builder.endMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 216:
//#line 528 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 217:
//#line 529 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 222:
//#line 538 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        param.name = val_peek(0).type.name;
        param.type = val_peek(2).type;
        param.dimensions = val_peek(0).type.dimensions;
        param.isVarArgs = val_peek(1).bval;
        builder.addParameter(param);
        param = new FieldDef();
    }
break;
case 223:
//#line 548 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.bval = false; }
break;
case 224:
//#line 549 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.bval = true; }
break;
case 226:
//#line 551 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addAnnotation((Annotation) val_peek(0).annoval); }
break;
case 228:
//#line 554 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ param.modifiers.add(val_peek(0).sval); }
break;
case 229:
//#line 555 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addAnnotation((Annotation) val_peek(0).annoval); }
break;
//#line 2127 "Parser.java"
//########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch
    //#### Now let's reduce... ####
    if (yydebug) debug("reduce");
    state_drop(yym);             //we just reduced yylen states
    yystate = state_peek(0);     //get new state
    val_drop(yym);               //corresponding value drop
    yym = yylhs[yyn];            //select next TERMINAL(on lhs)
    if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
      {
      debug("After reduction, shifting from state 0 to state "+YYFINAL+"");
      yystate = YYFINAL;         //explicitly say we're done
      state_push(YYFINAL);       //and save it
      val_push(yyval);           //also save the semantic value of parsing
      if (yychar < 0)            //we want another character?
        {
        yychar = yylex();        //get next character
        if (yychar<0) yychar=0;  //clean, if necessary
        if (yydebug)
          yylexdebug(yystate,yychar);
        }
      if (yychar == 0)          //Good exit (if lex returns 0 ;-)
         break;                 //quit the loop--all DONE
      }//if yystate
    else                        //else not done yet
      {                         //get next state and push, for next yydefred[]
      yyn = yygindex[yym];      //find out where to go
      if ((yyn != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn]; //get new state
      else
        yystate = yydgoto[yym]; //else go to new defred
      debug("after reduction, shifting from state "+state_peek(0)+" to state "+yystate+"");
      state_push(yystate);     //going again, so push state & val...
      val_push(yyval);         //for next action
      }
    }//main loop
  return 0;//yyaccept!!
}
//## end of method parse() ######################################



//## run() --- for Thread #######################################
//## The -Jnorun option was used ##
//## end of method run() ########################################



//## Constructors ###############################################
//## The -Jnoconstruct option was used ##
//###############################################################



}
//################### END OF CLASS ##############################
